#####################################################################################
#
#	:::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]:::
#				 ___                 _
#				| __| __ _  __ _  __| | _ _  ___  _ __
#				| _| / _` |/ _` |/ _` || '_|/ _ \| '_ \
#				|___|\__, |\__, |\__,_||_|  \___/| .__/
#				     |___/ |___/                 |_|
#
#####################################################################################
#
#      .
#
#   :
# !addnews <> -      ;
# !delnews < > -   ;
# !insnews < > <> -      ;
# !clearnews -      ;
# !statnews -     ,      ;
# !findnews < > -       ( -   );
# !news [], ! [], ! [] -    ( ).
#
#   :
# .chanset #chan [+|-]channews - /     !news.
#
#     data/news/ (  !)   .
#       "#.news" ( , #yourchan.news).
#
#   : Deniska #eggdrop @RusNet http://forum.eggdrop.org.ru
# , , : Adium #eggdrop @RusNet
#
###################################################################################
#	17.08.2008
#	v1.6 Edit by adium
#	-      ;
#	-         ( @RusNet);
#	-   / ,   
#	  ,    ;
#	-      ;
#	-     ,    ;
#	-   ;
#	-        ;
#	-      ;
#	-  debug;
#	-       ;
#
####
#	08.03.2008
#	v1.5 Edit by adium
#	-   ,      ;
#	-   DEBUG-;
#	-    ;
#	-    egglib_pub.tcl;
####
#	09.02.2008
#	v1.4 Edit by aduim
#	-  [::egglib::tolower $variable]     ;
#	-   [string is space $variable];
#	-         ;
#	-     ::channews::delnews;
#	-   ;
#	-       ;
#	-    ;
#	-    ,        ,
#	             ;
####
#	08.11.2007
#	v1.3 Edit by adium
#	-     ,  ;
#	-     ;
#	-      , 
#	    [ctime [unixtime]];
#	-         ;
###################################################################################

namespace eval channews {
	variable prefix			{!}
	variable flags			{mno|mno}
	variable author			{Deniska@RusNet}
	variable fix			{adium@RusNet}
	variable version		{1.6}
	variable date			{17-Aug-2008}
	variable unamespace		[namespace tail [namespace current]]
	#     .
	variable datapath		{data/news}
	#   
	variable msgspeed		2
	#    
	variable pause			45
	#    ,    ? [0/1]
	variable admover		1

	bind pub	$flags	${prefix}addnews		[namespace current]::addnews
	bind pub	$flags	${prefix}delnews		[namespace current]::delnews
	bind pub	$flags	${prefix}insnews		[namespace current]::insnews
	bind pub	$flags	${prefix}joinnews		[namespace current]::onoff
	bind pub	$flags	${prefix}clearnews		[namespace current]::clearnews
	bind pub	-|-		${prefix}news			[namespace current]::shownews
	bind pub	-|-		${prefix}		[namespace current]::shownews
	bind pub	-|-		${prefix}		[namespace current]::shownews
	bind pub	-|-		${prefix}statnews		[namespace current]::statnews
	bind pub	-|-		${prefix}findnews		[namespace current]::findnews
	bind pub	-|-		${prefix}fnews			[namespace current]::findnews

	setudef flag			$unamespace

	# only for debug! DON'T CHANGE!
	variable debug			1

# --------------------------------------------------
# ---------------- add new news --------------------
# --------------------------------------------------
	proc addnews {nick uhost hand chan text} {
		variable unamespace; variable msgspeed; variable prefix; variable debug; variable datapath
		if {![channel get $chan $unamespace]} {
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to ADD news on channel $chan, but channel $chan does not supported!}] -type err }
			return 0
		}
		set text [stripcodes cubr [string range $text 0 end]]
		if {$text eq ""} {
			output $nick [subst {\00314: \00306${prefix}addnews \00313<\00306\00313>\003}] -speed $msgspeed
			return 0
		}
		set chan [string tolower $chan]
		init $datapath $chan.news
		set news [readdata "$datapath/$chan.news"]
		set ourdate [clock format [clock seconds] -format "%d %m %Y"]
		if {$news eq ""} { set num 0 } else {
			foreach p $news { set num [lindex [stripcodes cubr $p] 0] }
		}
		incr num; lappend news [list $num $ourdate $nick $text]
		if {$debug} { debug [subst {$nick!$uhost ($hand) ADD news '$text' on channel $chan}] -type msg }
		writedata "$datapath/$chan.news" $news
		output $nick [subst {\00314 \00312#\00306$num\00314 .\003}] -speed $msgspeed
		return 0
	}

# --------------------------------------------------
# ---------------- del new news --------------------
# --------------------------------------------------

	proc delnews {nick uhost hand chan text} {
		variable unamespace; variable msgspeed; variable prefix; variable debug; variable datapath
		if {![channel get $chan $unamespace]} {
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to DEL news on channel $chan, but channel $chan does not supported!}] -type err }
			return 0
		}
		set chan [string tolower $chan]
		init $datapath $chan.news
		set news [readdata "$datapath/$chan.news"]
		if {$news eq ""} {
			output $nick [subst {\00314    .\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to DEL news on channel $chan, but data-file is empty!}] -type err }
			return 0
		}
		set text [stripcodes cubr [string range $text 0 end]]
		if {$text eq "" || ![regexp -- {^\d+$} $text]} {
			output $nick [subst {\00314: \00306${prefix}delnews\00313 <\00306 \00313>\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to DEL news on channel $chan -- syntax error: '$text'!}] -type err }
			return 0
		}
		if {[expr $text < 0] || [expr $text > [llength $news]]} {
			output $nick [subst {\00314   \00304[llength $news]\00314 [lindex {.   } [numgrp [llength $news]]].\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to DEL on channel $chan undefined news '$text'!}] -type err }
			return 0
		}
		set news [lreplace $news [expr $text - 1] [expr $text - 1]]
		writedata "$datapath/$chan.news" $news
		if {$debug} { debug [subst {$nick!$uhost ($hand) DEL news #$text on channel $chan}] -type msg }
		set news [readdata "$datapath/$chan.news"]
		set i 0
		foreach t $news {
			incr i
			if {[expr [lindex $t 0] > $text]} {
				set line [list [expr [lindex $t 0] - 1] [lindex $t 1] [lindex $t 2] [lindex $t 3] [lindex $t 4]]
				set news [lreplace $news [expr $i - 1] [expr $i - 1] $line]
				writedata "$datapath/$chan.news" $news
				if {$debug} { debug [subst {File '$datapath/$chan.news' successfully updated (renumbered all news indexes).}] -type msg }
			}
		}
		output $nick [subst {\00314 \00312#\00306$text\00314 .\003}] -speed $msgspeed
	}

# --------------------------------------------------
# --------------- insert new news ------------------
# --------------------------------------------------
	proc insnews {nick uhost hand chan text} {
		variable unamespace; variable msgspeed; variable prefix; variable debug; variable datapath
		if {![channel get $chan $unamespace]} {
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to INSERT new news on channel $chan, but channel $chan does not supported!}] -type err }
			return 0
		}
		set text [stripcodes cubr [string range $text 0 end]]
		if {$text eq ""} {
			output $nick [subst {\00314: \00306${prefix}insnews\00313 <\00306 \00313> <\00306\00313>\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to INSERT news on channel $chan, but string is space -- syntax error.}] -type err }
			return 0
		}
		set position [lindex $text 0]
		if {![regexp -- {^\d+$} $position]} {
			output $nick [subst {\00314:\00306 ${prefix}insnews\00313 <\00306 \00313> <\00306\00313>\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to INSERT news on channel $chan, but string index '$position' is wrong -- syntax error.}] -type err }
			return 0
		}
		set arg [lrange $text 1 end]
		if {$arg eq ""} {
			output $nick [subst {\00314:\00306 ${prefix}insnews\00313 <\00306 \00313> <\00306\00313>\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to INSERT news on channel $chan, but news string is space -- syntax error.}] -type err }
			return 0
		}
		set chan [string tolower $chan]
		init $datapath $chan.news
		set news [readdata "$datapath/$chan.news"]
		if {$news eq ""} {
			output $nick [subst {\00314     .\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to INSERT news on channel $chan, but data-file is empty!}] -type err }
			return 0
		}
		if {[expr $position <= 0]} {
			output $nick [subst {\00314     \00304\0021\002\00314.\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to INSERT news on channel $chan, but string index '$position' is wrong -- syntax error.}] -type err }
			return 0
		}
		if {[expr $position > [llength $news]]} {
			output $nick [subst {\00314   \00304\002[llength $news]\002\00314 [lindex {.   } [numgrp [llength $news]]].\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to INSERT news on channel $chan, but string index '$test' is wrong -- syntax error.}] -type err }
			return 0
		}
		set ourdate [clock format [clock seconds] -format "%d %m %Y"]
		if {$news eq ""} { set num 0 } else {
			foreach p $news { set num [lindex $p 0] }
		}
		incr num
		set news [linsert $news [expr $position - 1] [list $position $ourdate $nick $arg]]
		writedata "$datapath/$chan.news" $news
		set news [readdata "$datapath/$chan.news"]
		set i 0
		foreach t $news {
			incr i
			set line [list $i [lindex $t 1] [lindex $t 2] [lindex $t 3]]
			set news [lreplace $news [expr $i - 1] [expr $i - 1] $line]
			writedata "$datapath/$chan.news" $news
		}
		if {$debug} {
			debug [subst {File '$datapath/$chan.news' successfully updated (renumbered all news indexes).}] -type msg
			debug [subst {$nick!$uhost ($hand) INSERT new news '$arg' on channel $chan with string index '$position'.}] -type msg
			debug [subst {File '$datapath/$chan.news' successfully updated (inserted new news).}] -type msg
		}
		output $nick [subst {\00314  - \00312#\00306$position\00314.\003}] -speed $msgspeed
	}
	
# --------------------------------------------------
# ------------------ show news ---------------------
# --------------------------------------------------
	proc shownews {nick uhost hand chan text} {
		variable unamespace; variable msgspeed; variable prefix; variable debug; variable datapath
		if {![channel get $chan $unamespace]} {
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to VIEW news on channel $chan, but channel $chan does not supported!}] -type err }
			return 0
		}
		set text [stripcodes cubr [string range $text 0 end]]
		set chan [string tolower $chan]
		init $datapath $chan.news
		set news [readdata "$datapath/$chan.news"]
		if {$news eq ""} { 
			output $nick [subst {\00314   .\003}] -speed $msgspeed
			return 0
		}
		if {[checkflood $nick $uhost [namespace tail [lindex [info lev 0] 0]]]} {
			output $nick [subst {\00314    \00306${prefix}shownews\00314.  \00306[timewait $nick $uhost [namespace tail [lindex [info lev 0] 0]]] .\00314   ...\003}] -speed $msgspeed
			return 0
		}
		set newscount [llength $news]
		set newsindex [lindex $text 0]
		if {$newsindex ne "" && ![regexp -- {^\d+$} $newsindex]} {
			output $nick [subst {\00314:\00306 ${prefix}news\00313 \[\00306 \00313\]\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to VIEW news on channel $chan, but string index '$newsindex' is wrong -- syntax error.}] -type err }
			return 0
		}
		if {$newsindex ne ""} {
			set line [lindex $news [expr $newsindex - 1]]
			output $nick [subst {\00310 \[\00306[lindex $line 0]\00310\/$newscount\]: \00314[lindex $line 3] \00310\[\00305[lindex $line 2]\00310; \00305[string map {{ } {.}} [lindex $line 1]]\00310\]\003}] -speed $msgspeed
		} elseif {$newsindex eq ""} {
			foreach line $news { output $nick [subst {\00310 \[\00306[lindex $line 0]\00310\/$newscount\]: \00314[lindex $line 3] \00310\[\00305[lindex $line 2]\00310; \00305[string map {{ } {.}} [lindex $line 1]]\00310\]\003}] -speed $msgspeed }
		}
	}

# --------------------------------------------------
# --------------- clear all news -------------------
# --------------------------------------------------
	proc clearnews {nick uhost hand chan text} {
		variable unamespace; variable msgspeed; variable prefix; variable debug; variable datapath
		if {![channel get $chan $unamespace]} {
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to CLEAR all news on channel $chan, but channel $chan does not supported!}] -type err }
			return 0
		}
		set chan [string tolower $chan]
		set data [readdata "$datapath/$chan.news"]
		if {$data eq ""} {
			output $nick [subst {\00314     .\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to CLEAR all news on channel $chan, but file '$datapath/$chan.news' is empty.}] -type err }
			return 0
		}
		writedata "$datapath/$chan.news" [list]
		if {$debug} { debug [subst {$nick!$uhost ($hand) CLEAR all news on channel $chan}] -type msg }
		output $nick [subst {\00314  .\003}] -speed $msgspeed
	}
	
# --------------------------------------------------
# --------------- news small stat ------------------
# --------------------------------------------------
	proc statnews {nick uhost hand chan text} {
		variable unamespace; variable msgspeed; variable prefix; variable debug; variable datapath
		if {![channel get $chan $unamespace]} {
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to STAT news on channel $chan, but channel $chan does not supported!}] -type err }
			return 0
		}
		if {[checkflood $nick $uhost [namespace tail [lindex [info lev 0] 0]]]} {
			output $nick [subst {\00314    \00306${prefix}statnews\00314.  \00306[timewait $nick $uhost [namespace tail [lindex [info lev 0] 0]]] .\00314   ...\003}] -speed $msgspeed
			return 0
		}
		set chan [string tolower $chan]
		set data [readdata "$datapath/$chan.news"]
		if {$data eq ""} {
			output $nick [subst {\00314     .\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to STAT news on channel $chan, but file '$datapath/$chan.news' is empty.}] -type err }
			return 0
		}
		output $nick [subst {\00314   \00312[llength $data]\00314 [lindex {.   } [numgrp [llength $data]]].    \00306[lindex [lindex $data end] 2]\00314 [string map {{ } {.}} [lindex [lindex $data end] 1]]\003}] -speed $msgspeed
	}
	
# --------------------------------------------------
# ------------------ find news ---------------------
# --------------------------------------------------
	proc findnews {nick uhost hand chan text} {
		variable unamespace; variable msgspeed; variable prefix; variable debug; variable datapath
		if {![channel get $chan $unamespace]} {
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to FIND news on channel $chan, but channel $chan does not supported!}] -type err }
			return 0
		}
		if {[checkflood $nick $uhost [namespace tail [lindex [info lev 0] 0]]]} {
			output $nick [subst {\00314    \00306${prefix}findnews\00314.  \00306[timewait $nick $uhost [namespace tail [lindex [info lev 0] 0]]] .\00314   ...\003}] -speed $msgspeed
			return 0
		}
		set text [stripcodes cubr [string range $text 0 end]]
		set chan [string tolower $chan]
		set data [readdata "$datapath/$chan.news"]
		if {$data eq ""} {
			output $nick [subst {\00314     .\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to FIND news on channel $chan, but file '$datapath/$chan.news' is empty.}] -type err }
			return 0
		}
		if {$text eq ""} {
			output $nick [subst {\00314: \00306${prefix}findnews\00313 <\00306  \00313>\003}] -speed $msgspeed
			if {$debug} { debug [subst {$nick!$uhost ($hand) trying to FIND news on channel $chan, but string is space -- syntax error.}] -type err }
			return 0
		}
		set flist [list]; set num 0
		foreach line $data {
			incr num
			if {[string match -nocase "*$text" [lindex $line 3]] || [string match -nocase "$text*" [lindex $line 3]] || [string match -nocase "*$text*" [lindex $line 3]] || [string match -nocase "$text" [lindex $line 3]]} {
				lappend flist $num
			}
		}
		output $nick [subst {\00314 \00312[llength $flist]\00314 [lindex {.   } [numgrp $flist]]   '\00305$text\00314'.     :\00306 [string map {" " "\00314,\00306 "} $flist]\00314.\003}] -speed $msgspeed
	}

# --------------------------------------------------
# ------------- special functions ------------------
# --------------------------------------------------
	proc readdata {file} {
		if {![file exists $file]} { return "" } else {
			if {[catch {set fileio [open $file r]} r]} {return $r}
			set lines [list]
			while {![eof $fileio]} {
				set line [gets $fileio]
				if {![string is space $line]} { lappend lines $line }
			}
			close $fileio; return $lines
		}
	}
	
	proc writedata {file data} {
		if {[catch {set fileio [open $file w]} r]} {return $r}
		foreach line $data { puts $fileio $line }
		flush $fileio; close $fileio
	}
	
	proc init {dir data} {
		if {![file exists "$dir"]} { file mkdir "$dir" }
		if {![file exists "$dir/$data"]} { writedata "$dir/$data" [list] }
	}
	
	proc numgrp {number} { 
		switch -glob -- "$number" { 
			*11 {return 3} 
			*12 {return 3} 
			*13 {return 3} 
			*14 {return 3} 
			*1 {return 1} 
			*2 {return 2} 
			*3 {return 2} 
			*4 {return 2} 
			default {return 3} 
		}
	}
	
	variable ansi
	set ansi(cl) "\033\[0m"; set ansi(grn) "\033\[0;32m"; set ansi(cyn) "\033\[0;36m"
	set ansi(red) "\033\[0;31m"; set ansi(mag) "\033\[0;35m"; set ansi(yel) "\033\[0;33m"
	set ansi(blu) "\033\[0;34m"
	proc debug {str pn args} {
		importvars [list] $args [list type msg]
		if {[string tolower $type] ne "msg" && [string tolower $type] ne "err" && [string tolower $type] ne "wrn" && [string tolower $type] ne "ok"} {
			variable ansi
			return -code error "$ansi(red)wrong args$ansi(mag):$ansi(cyn) should be \"[namespace current]::debug string -type TYPE_NAME\"$ansi(cl)"
		}
		variable ansi
		switch -- [string tolower $type] {
			{ok}	{ putlog "$ansi(blu)[namespace current]::$pn $ansi(mag)->$ansi(grn) $str$ansi(cl)" }
			{msg}	{ putlog "$ansi(blu)[namespace current]::$pn $ansi(mag)->$ansi(cyn) $str$ansi(cl)" }
			{wrn}	{ putlog "$ansi(blu)[namespace current]::$pn $ansi(mag)->$ansi(yel) $str$ansi(cl)" }
			{err}	{ putlog "$ansi(blu)[namespace current]::$pn $ansi(mag)->$ansi(red) $str$ansi(cl)" }
			default { return "error" }
		}
	}
	
	proc output {c s args} {
		importvars [list] $args [list speed 2]
		if {[regexp -- {\d+} $speed]} {
			if {$speed == "0"} { set msg [string range $s 0 end]; append msg "\n"; putdccraw 0 [string length $msg] $msg
			} elseif {$speed == "1"} { 
				putquick "NOTICE $c :$s"
			} elseif {$speed == "2"} {
				putserv "NOTICE $c :$s"
			} elseif {$speed == "3"} {
				puthelp "NOTICE $c :$s"
			} else {
				variable ansi
				return -code error "$ansi(red)wrong args$ansi(grn):$ansi(cyn) should be \"[namespace current]::output chan string -speed NUM\"$ansi(cl)"
			}
		}
	}
	
	proc setdebug {t} {
		variable debug; variable unamespace; variable msgspeed
		if {$t eq ""} {
			debug [subst {       ${unamespace}.tcl  : 0 -  ; 1 -  .}] -type msg
			if {$debug eq 0} {
				debug [subst {      ${unamespace}.tcl .}] -type msg
				return 0
			} elseif {$debug eq 1} {
				debug [subst {      ${unamespace}.tcl .}] -type msg
				return 0
			}
		} else {
			if {$t ne 0 && $t ne 1} {
				debug [subst {   .  : 0 -  ; 1 -  .}] -type wrn
				return 0
			} elseif {$t eq 0 || $t eq 1} {
				set debug $t			
				debug [subst {   ${unamespace}.tcl [string map {0  1 } $t].}] -speed $msgspeed -type wrn
			}
		}
	}
	
	proc checkflood {nick uhost comm} {
		variable pause; variable lastcall; variable admover; variable debug; variable prefix
		if {$admover && ([matchattr $nick n] || [matchattr $nick m] || [matchattr $nick o])} {
			if {$debug} { debug [subst {$nick!$uhost use ${prefix}$comm. He matchattr m/o/n and floodcheck is override}] [namespace tail [lindex [info lev 0] 0]] -type wrn }
			return 0
		} elseif {!$admover} {
			if {$debug} { debug [subst {$nick!$uhost use ${prefix}$comm. Checking for flood...}] [namespace tail [lindex [info lev 0] 0]] -type wrn }
			if {[info exists lastcall($comm,$uhost)]} {
				if {[expr [expr [unixtime] - $lastcall($comm,$uhost)] < $pause]} {
					set det [expr [unixtime] - $lastcall($comm,$uhost)]
					set wtime [expr $pause - $det]
					if {$debug} { debug [subst {Flood detected: flooder - $nick!$uhost}] [namespace tail [lindex [info lev 0] 0]] -type wrn }
					return 1
				}
			}
		}
		set lastcall($comm,$uhost) [unixtime]
		if {$debug} { debug [subst {Flood not detected from $nick!$uhost}] [namespace tail [lindex [info lev 0] 0]] -type wrn }
		return 0
	}
	
	proc timewait {nick uhost comm} {
		variable pause; variable lastcall
		return [expr { $lastcall($comm,$uhost) + $pause - [unixtime] }]
	}
	
	proc importvars {lo {la {}} {ln {}}} {
		set lvars [list]
		foreach {var value} $ln {uplevel [list set $var $value]; lappend lvars $var}
		foreach {flag value} $la {
			if {[string index $flag 0] == "-"} {
				set var [string range $flag 1 end]
				uplevel [list set $var $value]
				lappend lvars $var
			}
		}
		foreach var $lo {
			if {[lsearch $lvars $var] < 0} {
				set value [uplevel 2 "if {\[info exists $var\]} {set $var} else {set $var \"\"}"]
				uplevel [list set $var $value]
			}
		}
	}
	
	debug [subst {v$version \[$date\] by $author (fixed by $fix) successfully loaded.}] [namespace tail [namespace current]] -type ok
}